program bierschieben;
{ Sokoban-Verschnitt }
{ 14.11.95: V.0.800     Spielfeld, Bewegungen + - Bierkaesten              }
{ 16.11.95: V.0.900     durchgehendes Spiel, Enderoutinen, Namenskorrektur }
{ 17.11.95: V.1.000     Sprites abgeaendert, Levels vom Amiga konvertiert  }


{$M 16384,0,655360}

uses crt,graph,intuit,dos,hiscore,timer;

const header='o   U J A s  Bierkastenschieber  o     V. 1.000      o      BP7      o';
      dx=16; dy=16; ox=16; oy=32; xmax=36; ymax=24;
      imafile='bier.ima'; levelfile='bier.l';
      hscfile='bier.hsc';

      cc:array[0..15,0..2] of integer=
(( 0,  0,  0),(54, 63, 57),( 0, 25, 25),(63, 54, 44),
 ( 0, 34, 34),( 0, 47, 47),(21, 63, 63),(43,  0,  0),
 (63, 14, 14),(63, 29, 29),(44, 29, 13),(63, 47,  6),
 (56, 48, 26),( 0, 31, 25),( 0, 47, 29),( 0, 63, 40));


type feld=array[0..succ(xmax),0..succ(ymax)] of integer;
     liste=array[0..xmax,0..1] of integer;

var ok,ende,fertig,aus         :boolean;
    ch                         :char;
    level,x0,y0,x,y,ri,ti,ti1,i:integer;
    ima                        :array[0..56] of image;
    stau                       :array[1..8] of image;
    f                          :feld;
    bier                       :liste;
    temp,lname                 :string;
    l,punkte                   :longint;
    ho,mi,se,tic,se1           :word;
    hsc                        :highscore;

{ --------------------------------------------------------------------- }
procedure bildschirm(var ok:boolean);
var i:integer;
begin
   initscreen(ok);
   if ok then begin
      for i:=0 to 15 do begin
         setpalette(i,0);
         setrgbpalette(i,cc[i,0],cc[i,1],cc[i,2]);
      end;
      rectfill(0,0,639,479,13);
      rectfill(8,8,635,23,0);
      rectfill(4,4,631,19,7);
      setcolor(1);
      line(4,4,4,18);
      line(4,4,631,4);
      setcolor(4);
      line(4,19,631,19);
      line(631,5,631,18);
      rectfill(8,460,635,475,0);
      rectfill(4,456,631,471,7);
      setcolor(1);
      line(4,456,4,470);
      line(4,456,631,456);
      setcolor(4);
      line(4,471,631,471);
      line(631,457,631,471);
      setcolor(0);
      outtextxy(38,8,header);
      setcolor(1);
      outtextxy(36,8,header);
   end;
end;

{ ----------------------------------------------------------------------- }

procedure getimages;
var i,j,k,anz:integer;
    fh   :file;
begin
assign(fh,imafile);
reset(fh,1);
BlockRead(fh,ima[0],sizeof(Image),anz);
with ima[0] do begin
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
   putimage(ox+dx,oy+dy,p_data^,normalput);
   FreeMem(p_data,anz);
end;
close(fh);

j:=ox+dx; k:=oy+dy;
for i:=1 to 27 do with ima[i] do begin
   x:=0; y:=0; width:=dx; height:=3*dy; p_nextimage:=nil;
   if i in [16..18,22..24] then width:=2*dx;
   if i in [25..27] then height:=dy;
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   getimage(j,k,j+pred(width),k+pred(height),p_data^);
   if i<25 then j:=j+width else k:=k+dy;
end;

j:=ox+dx; k:=oy+4*dy;
for i:=1 to 27 do with ima[i+27] do begin
   x:=0; y:=0; width:=dx; height:=3*dy; p_nextimage:=nil;
   if i in [16..18,22..24] then width:=2*dx;
   if i in [25..27] then height:=dy;
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   getimage(j,k,j+pred(width),k+pred(height),p_data^);
   if i<25 then j:=j+width else k:=k+dy;
end;
rectfill(0,oy+dy,639,oy+ymax*dy,13);

with ima[0] do begin
   x:=0;
   y:=0;
   width:=4*dx;
   height:=4*dy;
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   p_nextimage:=nil;
end;

end;


procedure getstauder;
var fh:file;
    i,j,k,anz:integer;
    temp:string;
begin
for i:=1 to 8 do begin
   temp:='stauder'+chr(48+i)+'.ima';
   assign(fh,temp);
   reset(fh,1);
   BlockRead(fh,stau[i],sizeof(Image),anz);
   with stau[i] do begin
      anz:=imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz,anz);
      putimage(ox+dx,oy+dy,p_data^,normalput);
   end;
end;
end;

{ --- }

procedure aufblenden;
var i:integer;
begin
   for i:=0 to 15 do setpalette(i,i);
end;

procedure abblenden;
var i:integer;
begin
   for i:=15 downto 0 do setpalette(i,0);
end;

{ ----------------------------------------------------------------------- }

procedure drawelement(x,y,z:integer);
begin
   case z of
   0: DrawImage(x*dx+ox,y*dy+oy,addr(ima[26]));
   1: DrawImage(x*dx+ox,y*dy+oy,addr(ima[54]));
   2: DrawImage(x*dx+ox,y*dy+oy,addr(ima[53]));
   3: DrawImage(x*dx+ox,y*dy+oy,addr(ima[27]));
   4: DrawImage(x*dx+ox,y*dy+oy,addr(ima[52]));
   5: DrawImage(x*dx+ox,y*dy+oy,addr(ima[25]));
   else DrawImage(x*dx+ox,y*dy+oy,addr(ima[26]));
   end;
end;

procedure zeichnesocke(x,xx,y,yy,z:integer; var f:feld);
const oyy=512;
var i,j,k,x1,y1:integer;
begin
   { hidden page zeichnen: }
   k:=0;
   for j:=y-2 to y+2 do begin
      for i:=x-1 to x+2 do case f[i,j] of
      0: DrawImage(i*dx+ox,k*dy+oyy,addr(ima[26]));
      1: DrawImage(i*dx+ox,k*dy+oyy,addr(ima[54]));
      2: DrawImage(i*dx+ox,k*dy+oyy,addr(ima[53]));
      3: DrawImage(i*dx+ox,k*dy+oyy,addr(ima[27]));
      4: DrawImage(i*dx+ox,k*dy+oyy,addr(ima[52]));
      5: DrawImage(i*dx+ox,k*dy+oyy,addr(ima[25]));
      else DrawImage(i*dx+ox,k*dy+oyy,addr(ima[26]));
      end;
      inc(k);
   end;
   x1:=x*dx+xx+ox;
   if z>21 then x1:=x1-dx;
   y1:=oyy+yy;
   putimage(x1,y1,ima[z].p_data^,andput);
   putimage(x1,y1,ima[z+27].p_data^,orput);

   getimage((x-1)*dx+ox,oyy,pred((x+3)*dx+ox),pred(oyy+4*dy),ima[0].p_data^);
   putimage((x-1)*dx+ox,(y-2)*dy+oy,ima[0].p_data^,normalput);

end;

{ ----------------------------------------------------------------------- }

procedure getlevel(var l:integer; var lname:string; var f:feld; var b:liste;
                   var x,y:integer);
const code=' *om#w&';
var i,j,k :integer;
    fh    :text;
    temp  :string;
    intern:boolean;
begin
for i:=0 to succ(xmax) do for j:=0 to succ(ymax) do f[i,j]:=0;
str(l:2,temp);
if temp[1]=' ' then temp[1]:='0';
temp:=levelfile+temp;
b[0,0]:=0;
{$i-}
assign(fh,temp);
reset(fh);
intern:=not (ioresult=0);
{$i+}
if intern then lname:='* I N T E R N *' else readln(fh,lname);
if intern then l:=0;
for j:=1 to ymax do begin
   if intern then case j of
        1: temp:='####################################';
    2.. 6: temp:='#                                  #';
        7: temp:='#######                            #';
        8: temp:='#ooo  ########       ###############';
        9: temp:='#ooo         #       #w            #';
       10: temp:='#ooo         #       #             #';
       11: temp:='#ooo  #####  #       #            &#';
       12: temp:='#######   #  #       #             #';
       13: temp:='#         # *#########      ########';
       14: temp:='#         #* *      *       #      #';
       15: temp:='#         #   *      *      #      #';
       16: temp:='#         ############* * * #      #';
       17: temp:='#                    # * * *#      #';
       18: temp:='#                    #      #      #';
       19: temp:='#                    ########      #';
   20..23: temp:='#                                  #';
       24: temp:='####################################';
   end else readln(fh,temp);

   if length(temp)>0 then for i:=1 to length(temp) do begin
      k:=pos(temp[i],code)-1;
      f[i,j]:=k;
      if k=6 then begin { Sockoban-Start }
         x:=i;
         y:=j;
         f[x,y]:=0;
      end;
      if (k=2) or (k=3) then begin { Bierkaesten }
         inc(b[0,0]);
         b[b[0,0],0]:=i;
         b[b[0,0],1]:=j;
      end;
   end;
end;
if not intern then close(fh);
x0:=x;
y0:=y;
end;


procedure initlevel(level:integer; levelname:string;
                    var f:feld; var x,y,ri:integer);
var i,j,k  :integer;
    temp,t2:string;
begin
rectfill(15,460,319,468,7);
str(level:2,temp);
temp:='o Level: '+temp+'  -  ';
t2:=levelname+'                     ';
t2:=copy(t2,1,20);
temp:=temp+t2+'  -  Zeit: xxxx s  -  Punkte: xxxxxx   o';
setcolor(0); outtextxy(16,460,temp);
setcolor(1); outtextxy(15,460,temp);
ri:=2;
x:=x0;
y:=y0;
for i:=1 to xmax do for j:=1 to ymax do DrawElement(i,j,f[i,j]);
zeichnesocke(x,0,y,0,1,f);
end;

procedure updattime(t:integer);
const x=391; y=460;
var temp:string;
begin
   str(t:4,temp);
   rectfill(x,y,x+39,y+7,7);
   setcolor(0); outtextxy(x+1,460,temp);
   setcolor(1); outtextxy(x,460,temp);
end;

procedure updatpunkte(p:longint);
const x=543; y=460;
var temp:string;
begin
   str(p:6,temp);
   rectfill(x,y,x+63,y+7,7);
   setcolor(0); outtextxy(x+1,460,temp);
   setcolor(1); outtextxy(x,460,temp);
end;

procedure movesocke(var x,y,ri:integer; var f:feld);
var i,j,k:integer;
begin
   case ri of
   0: if f[x,y-1] in [0,2] then begin  { leer, nach oben }
         dec(y);
         i:=0;
         j:=dy;
         k:=7;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=8;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=7;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=9;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=7;
         zeichnesocke(x,i,y,j,k,f);
      end else if (f[x,y-1] in [1,3]) and (f[x,y-2] in [0,2]) then begin
         f[x,y-1]:=f[x,y-1]-1;
         dec(y);
         i:=0;
         j:=dy;
         k:=19;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=20;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=19;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=21;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j-4;
         k:=19;
         zeichnesocke(x,i,y,j,k,f);
         f[x,y-1]:=f[x,y-1]+1;
         k:=7;
         zeichnesocke(x,i,y,j,k,f);
      end;
   1: if f[x+1,y] in [0,2] then begin  { leer, nach rechts }
         i:=0;
         j:=0;
         k:=4;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=5;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=4;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=6;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=4;
         zeichnesocke(x,i,y,j,k,f);
         inc(x);
      end else if (f[x+1,y] in [1,3]) and (f[x+2,y] in [0,2]) then begin
         f[x+1,y]:=f[x+1,y]-1;
         i:=0;
         j:=0;
         k:=16;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=17;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=16;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i+4;
         k:=18;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         inc(x);
         i:=0;
         k:=16;
         zeichnesocke(x,i,y,j,k,f);
         f[x+1,y]:=f[x+1,y]+1;
         k:=4;
         zeichnesocke(x,i,y,j,k,f);
      end;
   2: if f[x,y+1] in [0,2] then begin  { leer, nach unten }
         i:=0;
         j:=0;
         k:=1;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=2;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=1;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=3;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=1;
         zeichnesocke(x,i,y,j,k,f);
         inc(y);
      end else if (f[x,y+1] in [1,3]) and (f[x,y+2] in [0,2]) then begin
         f[x,y+1]:=f[x,y+1]-1;
         i:=0;
         j:=0;
         k:=13;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=14;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=13;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=15;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         j:=j+4;
         k:=13;
         zeichnesocke(x,i,y,j,k,f);
         inc(y);
         f[x,y+1]:=f[x,y+1]+1;
         k:=1;
         j:=0;
         zeichnesocke(x,i,y,j,k,f);
      end;
   3: if f[x-1,y] in [0,2] then begin  { leer, nach links }
         dec(x);
         i:=dx;
         j:=0;
         k:=10;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=11;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=10;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=12;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=10;
         zeichnesocke(x,i,y,j,k,f);
      end else if (f[x-1,y] in [1,3]) and (f[x-2,y] in [0,2]) then begin
         f[x-1,y]:=f[x-1,y]-1;
         dec(x);
         i:=dx;
         j:=0;
         k:=22;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=23;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=22;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=24;
         zeichnesocke(x,i,y,j,k,f);
         delay1(ti);
         i:=i-4;
         k:=22;
         zeichnesocke(x,i,y,j,k,f);
         f[x-1,y]:=f[x-1,y]+1;
         k:=10;
         zeichnesocke(x,i,y,j,k,f);
      end;
   end;
end;

{ --- }

procedure istfertig;
var i,j,x,y,z:integer;
    l        :longint;
begin
for x:=1 to 10 do begin
   for i:=1 to bier[0,0] do
   drawimage(bier[i,0]*dx+ox,bier[i,1]*dy+oy,addr(ima[25]));
   delay1(ti*2);
   for i:=1 to bier[0,0] do
   drawimage(bier[i,0]*dx+ox,bier[i,1]*dy+oy,addr(ima[53]));
   delay1(ti*2);
   for i:=1 to bier[0,0] do
   drawimage(bier[i,0]*dx+ox,bier[i,1]*dy+oy,addr(ima[54]));
   delay1(ti*2);
end;

for i:=0 to 24 do begin
   x:=succ(i mod 8);
   putimage(15*dx+ox,8*dy+oy,stau[x].p_data^,normalput);
   delay1(ti div 8);
end;

delay1(ti);

for l:=0 to 200000 do begin
   x:=dx+ox+random(xmax*dx);
   y:=dy+oy+random(ymax*dy);
   putpixel(x,y,13);
end;
delay1(ti);
end;

{ ----------------------------------------------------------------------- }

procedure preloop;
begin
         abblenden;
         getlevel(level,lname,f,bier,x0,y0);
         initlevel(level,lname,f,x,y,ri);
         updatpunkte(punkte);
         aufblenden;
         fertig:=false;
         aus:=false;
         gettime(ho,mi,se,tic);
         se1:=se;
         ti1:=bier[0,0]*50;
end;



begin
   ti:=50;
   if paramcount>0 then begin
      temp:=paramstr(1);
      val(temp,ri,i);
      if i=0 then ti:=ri;
      if ti<1 then ti:=1;
      if ti>100 then ti:=100;
      ti:=ti*10
   end;

   bildschirm(ok);
   if ok then begin
      getstauder;
      getimages;
      loadhighscore(hscfile,hsc);

      showhighscore(hsc,12*dx+ox,8*dy+oy,dy,3,1,7,0);
      aufblenden;
      ende:=readkey=#27;
      punkte:=0;
      level:=1;

      repeat   { Level-Loop }
         preloop;
         repeat   { Game-Loop }
            repeat
            gettime(ho,mi,se,tic);
            if se<>se1 then begin
               se1:=se;
               dec(ti1);
               updattime(ti1);
               aus:=ti1<1;
               delay1(10);
            end;
            until keypressed;
            ch:='.';
            while keypressed do ch:=readkey;
            if ch<>'.' then begin
               case ch of
               #72: ri:=0;
               #75: ri:=3;
               #77: ri:=1;
               #80: ri:=2;
               #27: ende:=true;
               '+': begin
                       inc(level);
                       preloop;
                    end;
               '-': begin
                       dec(level);
                       preloop;
                    end;
               '0': preloop;
            end;
            if (ch>#71) and (ch<#81) then begin
               movesocke(x,y,ri,f);
               fertig:=true;
               for i:=1 to bier[0,0] do if f[bier[i,0],bier[i,1]]=2 then fertig:=false;
            end;

         end;

         until ende or fertig or aus;    { Game-Loop }

         if fertig then begin
            punkte:=punkte+ti1;
            updatpunkte(punkte);
            istfertig;
            inc(level);
            while keypressed do ende:=readkey=#27;
            ende:=readkey=#27;
         end;
         if aus then begin
            rectfill(ox+dx,oy+dy,xmax*dx+ox+pred(dx),ymax*dy+pred(dy),13);
            rectfill(3*dx+ox,3*dy+oy,(xmax-1)*dx+ox,ymax*dy,0);
            rectfill(4*dx+ox-1,4*dy+oy-1,(xmax-2)*dx+ox+1,(ymax-1)*dy+1,1);
            rectfill(4*dx+ox,4*dy+oy,(xmax-2)*dx+ox,(ymax-1)*dy,7);
            temp:='***   F e i e r a b e n d !   ***';
            setcolor(0); outtextxy(10*dx+ox+9,6*dy+oy,temp);
            setcolor(1); outtextxy(10*dx+ox+8,6*dy+oy,temp);
            putimage(30*dx+ox,16*dy+oy,ima[4].p_data^,andput);
            putimage(30*dx+ox,16*dy+oy,ima[31].p_data^,orput);
            delay1(1000);
            updathighscore(punkte,hscfile,hsc,11*dx+ox,8*dy+oy,dy,3,1,7,0);
            ende:=readkey=#27;
            punkte:=0;
         end;
      until ende;    { Level-Loop }

   end;
   textmode(3);
 end.

